signature PROOFS =
sig
  include DEFINITIONS

  val projl : 'a * 'b -> 'a
  val projr : 'a * 'b -> 'b

  val conj_over_conj : ('a * ('b * 'c), ('a * 'b) * ('a * 'c)) iff
  val conj_over_disj : ('a * ('b,'c) or,('a * 'b,'a * 'c) or) iff
  val imp_over_imp   : ('a -> 'b -> 'c) -> ('a -> 'b) -> 'a -> 'c
  val imp_over_iff   : ('a -> ('b,'c) iff,('a -> 'b,'a -> 'c) iff) iff
  val schoenfinkel   : ('a -> 'b -> 'c,'a * 'b -> 'c) iff

  val demorgan_cong  : ('a not, 'b not) or -> ('a * 'b) not
  val demorgan_disj  : (('a,'b) or not, ('a not) * ('b not)) iff

  val contrapos      : ('a -> 'b) -> ('b not -> 'a not)
end
